declare type Validate = (data: string | number) => boolean | string | number | Date;
declare type NumberOrString = number | string;
declare type Props = {
    mode: 'onSubmit' | 'onBlur' | 'onChange';
    validationSchema?: any;
};
declare type MutationWatcher = {
    disconnect: () => void;
};
export declare type Ref = any;
export interface IRegisterInput {
    ref: Ref;
    required?: boolean | string;
    min?: NumberOrString | {
        value: NumberOrString;
        message: string;
    };
    max?: NumberOrString | {
        value: NumberOrString;
        message: string;
    };
    maxLength?: number | {
        value: number;
        message: string;
    };
    minLength?: number | {
        value: number;
        message: string;
    };
    pattern?: RegExp | {
        value: RegExp;
        message: string;
    };
    validate?: Validate | {
        [key: string]: Validate;
    } | {
        value: Validate | {
            [key: string]: Validate;
        };
        message: string;
    } | undefined;
}
export interface IField extends IRegisterInput {
    ref: Ref;
    watch?: boolean;
    mutationWatcher?: MutationWatcher;
    fields?: Array<IRegisterInput>;
    options?: Array<{
        ref: Ref;
        mutationWatcher?: MutationWatcher;
    }>;
}
declare type Error = {
    ref: Ref;
    message: string | boolean;
    type: string;
};
export interface IErrorMessages {
    [key: string]: Error;
}
export default function useForm({ mode, validationSchema }?: Props): {
    register: (data: any) => (ref: any) => void;
    handleSubmit: (callback: (Object: any, e: any) => void) => (e: any) => Promise<void>;
    errors: IErrorMessages;
    watch: (filedNames?: string | string[], defaultValue?: string | string[]) => any;
    formState: {
        dirty: boolean;
        isSubmitted: boolean;
        touched: string[];
    };
};
export {};
